﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Collections.Generic;

namespace CustomerManager
{
    public class Session
    {
        public string Description { get; set; }
        public int LengthInMins { get; set; }

        public Session(string inDescription, int inLength)
        {
            Description = inDescription;
            LengthInMins = inLength;
        }
    }

    public class Customer
    {
        public string Name { get; set; }
        public string Address { get; set; }
        public int ID { get; set; }

        public List<Session> Sessions;

        public Customer(string inName, string inAddress, int inID)
        {
            Name = inName;
            Address = inAddress;
            ID = inID;
            Sessions = new List<Session>();
        }
    }

    public class Customers
    {
        public string Name { get; set; }

        public Customers(string inName)
        {
            Name = inName;
            CustomerList = new List<Customer>();
        }

        public List<Customer> CustomerList;

        public static Customers MakeTestCustomers()
        {
            string[] firstNames = new string[] { "Rob", "Jim", "Joe", "Nigel", "Sally", "Tim" };
            string[] lastsNames = new string[] { "Smith", "Jones", "Bloggs", "Miles", "Wilkinson", "Brown" };
            Customers result = new Customers("Test Customers");
            int id = 0;

            // Use a fixed squence of random numbers to make the same data each time
            Random sessionRand = new Random(1);

            foreach (string lastName in lastsNames)
            {
                foreach (string firstname in firstNames)
                {
                    //Construct a customer name
                    string name = firstname + " " + lastName;

                    // Make a new customer
                    Customer newCustomer = new Customer(name, name + "'s House", id);

                    // Create some test sessions
                    int noOfSessions = sessionRand.Next(1,4);
                    for (int i = 0; i < noOfSessions; i++)
                    {
                        int sessionLength = sessionRand.Next(5,120);
                        string sessionDesc = "Session" + i.ToString();
                        Session s = new Session(sessionDesc, sessionLength);
                        newCustomer.Sessions.Add(s);
                    }

                    //Add the new customer to the list
                    result.CustomerList.Add(newCustomer);
                    // Increase the ID for the next customer
                    id++;
                }
            }
            return result;
        }
    }
}
